3 # Copyright (c) 2005 Junio C Hamano
5 # Fetch one or more remote refs and merge it/them into the current HEAD.
7 USAGE='[-n | --no-stat] [--[no-]commit] [--[no-]squash] [--[no-]ff|--ff-only] [--[no-]rebase|--rebase=preserve] [-s strategy]... [<fetch-options>] <repo> <head>...'
8 LONG_USAGE='Fetch one or more remote refs and integrate it/them with the current HEAD.'
13 set_reflog_action "pull${1+ $*}"
14 require_work_tree_exists
19 git diff-index --cached --name-status -r --ignore-submodules HEAD --
20 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
21 die "$(gettext "Pull is not possible because you have unmerged files.
22 Please, fix them up in the work tree, and then use 'git add/rm <file>'
23 as appropriate to mark resolution, or use 'git commit -a'.")"
25 die "$(gettext "Pull is not possible because you have unmerged files.")"
30 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
31 die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).
32 Please, commit your changes before you can merge.")"
34 die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).")"
38 test -z "$(git ls-files -u)" || die_conflict
39 test -f "$GIT_DIR/MERGE_HEAD" && die_merge
41 bool_or_string_config () {
42 git config --bool "$1" 2>/dev/null || git config "$1"
45 strategy_args= diffstat= no_commit= squash= no_ff= ff_only=
46 log_arg= verbosity= progress= recurse_submodules= verify_signatures=
47 merge_args= edit= rebase_args=
48 curr_branch=$(git symbolic-ref -q HEAD)
49 curr_branch_short="${curr_branch#refs/heads/}"
50 rebase=$(bool_or_string_config branch.$curr_branch_short.rebase)
53 rebase=$(bool_or_string_config pull.rebase)
56 # Setup default fast-forward options via `pull.ff`
57 pull_ff=$(git config pull.ff)
73 verbosity="$verbosity -q" ;;
75 verbosity="$verbosity -v" ;;
77 progress=--progress ;;
79 progress=--no-progress ;;
80 -n|--no-stat|--no-summary)
86 --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
87 no_commit=--no-commit ;;
88 --c|--co|--com|--comm|--commi|--commit)
94 --sq|--squ|--squa|--squas|--squash)
96 --no-sq|--no-squ|--no-squa|--no-squas|--no-squash)
104 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
105 --strateg=*|--strategy=*|\
106 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
109 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
116 strategy_args="${strategy_args}-s $strategy "
123 xx="-X $(git rev-parse --sq-quote "$2")"
126 xx=$(git rev-parse --sq-quote "$1") ;;
128 merge_args="$merge_args$xx "
130 -r=*|--r=*|--re=*|--reb=*|--reba=*|--rebas=*|--rebase=*)
133 -r|--r|--re|--reb|--reba|--rebas|--rebase)
136 --no-r|--no-re|--no-reb|--no-reba|--no-rebas|--no-rebase)
139 --recurse-submodules)
140 recurse_submodules=--recurse-submodules
142 --recurse-submodules=*)
143 recurse_submodules="$1"
145 --no-recurse-submodules)
146 recurse_submodules=--no-recurse-submodules
149 verify_signatures=--verify-signatures
151 --no-verify-signatures)
152 verify_signatures=--no-verify-signatures
158 gpg_sign_args=$(git rev-parse --sq-quote "-S${1#--gpg-sign=}")
161 gpg_sign_args=$(git rev-parse --sq-quote "$1")
163 --d|--dr|--dry|--dry-|--dry-r|--dry-ru|--dry-run)
170 # Pass thru anything that may be meant for fetch.
180 rebase_args=--preserve-merges
185 echo "Invalid value for --rebase, should be true, false, or preserve"
191 error_on_no_merge_candidates () {
196 -t|--t|--ta|--tag|--tags)
197 echo "It doesn't make sense to pull all tags; you probably meant:"
198 echo " git fetch --tags"
203 if test true = "$rebase"
212 upstream=$(git config "branch.$curr_branch_short.merge")
213 remote=$(git config "branch.$curr_branch_short.remote")
215 if [ $# -gt 1 ]; then
216 if [ "$rebase" = true ]; then
217 printf "There is no candidate for rebasing against "
219 printf "There are no candidates for merging "
221 echo "among the refs that you just fetched."
222 echo "Generally this means that you provided a wildcard refspec which had no"
223 echo "matches on the remote end."
224 elif [ $# -gt 0 ] && [ "$1" != "$remote" ]; then
225 echo "You asked to pull from the remote '$1', but did not specify"
226 echo "a branch. Because this is not the default configured remote"
227 echo "for your current branch, you must specify a branch on the command line."
228 elif [ -z "$curr_branch" -o -z "$upstream" ]; then
230 error_on_missing_default_upstream "pull" $op_type $op_prep \
231 "git pull <remote> <branch>"
233 echo "Your configuration specifies to $op_type $op_prep the ref '${upstream#refs/heads/}'"
234 echo "from the remote, but no such ref was fetched."
239 test true = "$rebase" && {
240 if ! git rev-parse -q --verify HEAD >/dev/null
242 # On an unborn branch
243 if test -f "$GIT_DIR/index"
245 die "$(gettext "updating an unborn branch with changes added to the index")"
248 require_clean_work_tree "pull with rebase" "Please commit or stash them."
251 test -n "$curr_branch" &&
252 . git-parse-remote &&
253 remoteref="$(get_remote_merge_branch "$@" 2>/dev/null)" &&
254 oldremoteref=$(git merge-base --fork-point "$remoteref" $curr_branch 2>/dev/null)
256 orig_head=$(git rev-parse -q --verify HEAD)
257 git fetch $verbosity $progress $dry_run $recurse_submodules --update-head-ok "$@" || exit 1
258 test -z "$dry_run" || exit 0
260 curr_head=$(git rev-parse -q --verify HEAD)
261 if test -n "$orig_head" && test "$curr_head" != "$orig_head"
263 # The fetch involved updating the current branch.
265 # The working tree and the index file is still based on the
266 # $orig_head commit, but we are merging into $curr_head.
267 # First update the working tree to match $curr_head.
269 eval_gettextln "Warning: fetch updated the current branch head.
270 Warning: fast-forwarding your working tree from
271 Warning: commit \$orig_head." >&2
272 git update-index -q --refresh
273 git read-tree -u -m "$orig_head" "$curr_head" ||
274 die "$(eval_gettext "Cannot fast-forward your working tree.
275 After making sure that you saved anything precious from
276 $ git diff \$orig_head
283 merge_head=$(sed -e '/ not-for-merge /d' \
284 -e 's/ .*//' "$GIT_DIR"/FETCH_HEAD | \
287 case "$merge_head" in
289 error_on_no_merge_candidates "$@"
292 if test -z "$orig_head"
294 die "$(gettext "Cannot merge multiple branches into empty head")"
296 if test true = "$rebase"
298 die "$(gettext "Cannot rebase onto multiple branches")"
303 # Pulling into unborn branch: a shorthand for branching off
304 # FETCH_HEAD, for lazy typers.
305 if test -z "$orig_head"
307 # Two-way merge: we claim the index is based on an empty tree,
308 # and try to fast-forward to HEAD. This ensures we will not
309 # lose index/worktree changes that the user already made on
311 empty_tree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
312 git read-tree -m -u $empty_tree $merge_head &&
313 git update-ref -m "initial pull" HEAD $merge_head "$curr_head"
317 if test true = "$rebase"
319 o=$(git show-branch --merge-base $curr_branch $merge_head $oldremoteref)
320 if test "$oldremoteref" = "$o"
326 merge_name=$(git fmt-merge-msg $log_arg <"$GIT_DIR/FETCH_HEAD") || exit
329 eval="git-rebase $diffstat $strategy_args $merge_args $rebase_args $verbosity"
330 eval="$eval $gpg_sign_args"
331 eval="$eval --onto $merge_head ${oldremoteref:-$merge_head}"
334 eval="git-merge $diffstat $no_commit $verify_signatures $edit $squash $no_ff $ff_only"
335 eval="$eval $log_arg $strategy_args $merge_args $verbosity $progress"
336 eval="$eval $gpg_sign_args"
337 eval="$eval \"\$merge_name\" HEAD $merge_head"